# Ipopt::CompoundMatrix Class Reference

Class for Matrices consisting of other matrices. More...

`#include <IpCompoundMatrix.hpp>`

Inheritance diagram for Ipopt::CompoundMatrix:
[legend]

List of all members.

## Public Member Functions
void | SetComp (Index irow, Index jcol, const Matrix &matrix)
| Method for setting an individual component at position (irow, icol) in the compound matrix.
void | SetCompNonConst (Index irow, Index jcol, Matrix &matrix)
| Method to set a non-const Matrix entry.
void | CreateBlockFromSpace (Index irow, Index jcol)
| Method to create a new matrix from the space for this block.
SmartPtr< const Matrix > | GetComp (Index irow, Index jcol) const
| Method for retrieving one block from the compound matrix as a const Matrix.
SmartPtr< Matrix > | GetCompNonConst (Index irow, Index jcol)
| Method for retrieving one block from the compound matrix as a non-const Matrix.
Index | NComps_Rows () const
| Number of block rows of this compound matrix.
Index | NComps_Cols () const
| Number of block colmuns of this compound matrix.
Constructors / Destructors
| CompoundMatrix (const CompoundMatrixSpace *owner_space)
| Constructor, taking the owner_space.
virtual | ~CompoundMatrix ()
| Destructor.
## Protected Member Functions
Methods overloaded from Matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply.
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = beta*X + alpha*(Matrix S^{-1} Z).
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td).
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Compute the max-norm of the columns in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
bool | MatricesValid () const
| Method to check whether or not the matrices are valid.
const Matrix * | ConstComp (Index irow, Index jcol) const
Matrix * | Comp (Index irow, Index jcol)
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| CompoundMatrix ()
| Default Constructor.
| CompoundMatrix (const CompoundMatrix &)
| Copy Constructor.
void | operator= (const CompoundMatrix &)
| Overloaded Equals Operator.
## Private Attributes
std::vector< std::vector < SmartPtr< Matrix > > > | comps_
| Matrix of matrix's containing the components.
std::vector< std::vector < SmartPtr< const Matrix > > > | const_comps_
| Matrix of const matrix's containing the components.
const CompoundMatrixSpace * | owner_space_
| Copy of the owner_space ptr as a CompoundMatrixSpace instead of MatrixSpace.
bool | matrices_valid_
| boolean indicating if the compound matrix is in a "valid" state

## Detailed Description

Class for Matrices consisting of other matrices.

This matrix is a matrix that consists of zero, one or more Matrices's which are arranged like this: . The individual components can be associated to different MatrixSpaces. The individual components can also be const and non-const Matrices. If a component is not set (i.e., it's pointer is NULL), then this components is treated like a zero-matrix of appropriate dimensions.

Definition at line 34 of file IpCompoundMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::CompoundMatrix::CompoundMatrix | ( | const CompoundMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

The owner_space has to be defined, so that at each block row and column contain at least one non-NULL component. The individual components can be set afterwards with the SeteComp and SetCompNonConst methods.

virtual Ipopt::CompoundMatrix::~CompoundMatrix | ( |  | ) | `[virtual]`

Destructor.

Ipopt::CompoundMatrix::CompoundMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::CompoundMatrix::CompoundMatrix | ( | const CompoundMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::CompoundMatrix::SetComp | ( | Index | irow,
|  | Index | jcol,
|  | const Matrix & | matrix |
| ) |  |  |

Method for setting an individual component at position (irow, icol) in the compound matrix.

The counting of indices starts at 0.

void Ipopt::CompoundMatrix::SetCompNonConst | ( | Index | irow,
|  | Index | jcol,
|  | Matrix & | matrix |
| ) |  |  |

Method to set a non-const Matrix entry.

void Ipopt::CompoundMatrix::CreateBlockFromSpace | ( | Index | irow,
|  | Index | jcol |
| ) |  |  |

Method to create a new matrix from the space for this block.

SmartPtr<const Matrix> Ipopt::CompoundMatrix::GetComp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | const`[inline]`

Method for retrieving one block from the compound matrix as a const Matrix.

Definition at line 67 of file IpCompoundMatrix.hpp.

SmartPtr<Matrix> Ipopt::CompoundMatrix::GetCompNonConst | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | `[inline]`

Method for retrieving one block from the compound matrix as a non-const Matrix.

Note that calling this method with mark the CompoundMatrix as changed. Therefore, only use this method if you are intending to change the Matrix that you receive.

Definition at line 76 of file IpCompoundMatrix.hpp.

Index Ipopt::CompoundMatrix::NComps_Rows | ( |  | ) | const`[inline]`

Number of block rows of this compound matrix.

Definition at line 305 of file IpCompoundMatrix.hpp.

Index Ipopt::CompoundMatrix::NComps_Cols | ( |  | ) | const`[inline]`

Number of block colmuns of this compound matrix.

Definition at line 311 of file IpCompoundMatrix.hpp.

virtual void Ipopt::CompoundMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::AddMSinvZImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | Z,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = beta*X + alpha*(Matrix S^{-1} Z).

Specialized implementation.

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::SinvBlrmZMTdBrImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | R,
|  | const Vector & | Z,
|  | const Vector & | D,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = S^{-1} (r + alpha*Z*M^Td).

Specialized implementation.

Reimplemented from Ipopt::Matrix.

virtual bool Ipopt::CompoundMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::CompoundMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::CompoundMatrix::operator= | ( | const CompoundMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::Matrix.

bool Ipopt::CompoundMatrix::MatricesValid | ( |  | ) | const`[private]`

Method to check whether or not the matrices are valid.

const Matrix * Ipopt::CompoundMatrix::ConstComp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | const`[inline, private]`

Definition at line 317 of file IpCompoundMatrix.hpp.

Matrix * Ipopt::CompoundMatrix::Comp | ( | Index | irow,
|  | Index | jcol |
| ) |  |  | `[inline, private]`

Definition at line 332 of file IpCompoundMatrix.hpp.

## Member Data Documentation

std::vector<std::vector<SmartPtr<Matrix> > > Ipopt::CompoundMatrix::comps_`[private]`

Matrix of matrix's containing the components.

Definition at line 143 of file IpCompoundMatrix.hpp.

std::vector<std::vector<SmartPtr<const Matrix> > > Ipopt::CompoundMatrix::const_comps_`[private]`

Matrix of const matrix's containing the components.

Definition at line 146 of file IpCompoundMatrix.hpp.

const CompoundMatrixSpace* Ipopt::CompoundMatrix::owner_space_`[private]`

Copy of the owner_space ptr as a CompoundMatrixSpace instead of MatrixSpace.

Reimplemented from Ipopt::Matrix.

Definition at line 150 of file IpCompoundMatrix.hpp.

bool Ipopt::CompoundMatrix::matrices_valid_`[mutable, private]`

boolean indicating if the compound matrix is in a "valid" state

Definition at line 153 of file IpCompoundMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpCompoundMatrix.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines